#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n,k;
    cin >> n >> k;
    string s;
    cin >> s;
    map<char,int> c;
    string x = "abcdefghijklmnopqrstuvwxyz";
    int l = 0;
    for(int i = 0;i < n;i++){
        c[s[i]]++;
        int mn = 200005,mx = -1;
        for(int j = 0;j < k;j++){
            mn = min(c[x[j]],mn);
            mx = max(c[x[j]],mx);
        }
        if(mx == mn){
            l++;
        }
        cout << l+1 << ' ';
    }

    return 0;
}